#ifndef SUBJECTIF_H
#define SUBJECTIF_H

#include <memory>
#include <functional>

using Observer = std::function<void ()>;

class RegistrationTokenIf
{
public:
    virtual ~RegistrationTokenIf() {};
};

class SubjectIf
{
public:

    virtual ~SubjectIf() {}

    virtual std::unique_ptr<RegistrationTokenIf> registerObserver(const Observer& observer) = 0;

};

#endif // SUBJECTIF_H
